import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetPipelineStateCommand, se_GetPipelineStateCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class GetPipelineStateCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodePipeline_20150709", "GetPipelineState", {})
    .n("CodePipelineClient", "GetPipelineStateCommand")
    .f(void 0, void 0)
    .ser(se_GetPipelineStateCommand)
    .de(de_GetPipelineStateCommand)
    .build() {
}
