import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { CodePipelineClientResolvedConfig } from "../CodePipelineClient";
export interface CodePipelineHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface CodePipelineHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    CodePipelineClientResolvedConfig,
    HandlerExecutionContext,
    CodePipelineHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultCodePipelineHttpAuthSchemeParametersProvider: (
  config: CodePipelineClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<CodePipelineHttpAuthSchemeParameters>;
export interface CodePipelineHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<CodePipelineHttpAuthSchemeParameters> {}
export declare const defaultCodePipelineHttpAuthSchemeProvider: CodePipelineHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: CodePipelineHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: CodePipelineHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
